    SH_DIR = 2
    DIR_R  = 0<<SH_DIR
    DIR_D  = 1<<SH_DIR
    DIR_RU = 2<<SH_DIR
    DIR_RD = 3<<SH_DIR
    SH_LEN = 4
    LEN_1  =  0<<SH_LEN
    LEN_2  =  1<<SH_LEN
    LEN_3  =  2<<SH_LEN
    LEN_4  =  3<<SH_LEN
    LEN_5  =  4<<SH_LEN
    LEN_6  =  5<<SH_LEN
    LEN_7  =  6<<SH_LEN
    LEN_8  =  7<<SH_LEN
    LEN_9  =  8<<SH_LEN
    LEN_10 =  9<<SH_LEN
    LEN_11 = 10<<SH_LEN
    LEN_12 = 11<<SH_LEN
    LEN_13 = 12<<SH_LEN
    LEN_14 = 13<<SH_LEN
    LEN_15 = 14<<SH_LEN
    LEN_16 = 15<<SH_LEN
    
    SH_AI = 0
    AI_FLOATER = 0<<SH_AI
    AI_CRAWLER = 1<<SH_AI
    AI_REACTOR = 2<<SH_AI

* = $1f00
StartOfRoomsUnrelocated
!pseudopc $300 {
StartOfRooms

Room3 ; big diagonal
!byte $31, 1
!byte $61, 1
!byte $7e, 1
!byte $bd, 1 + DIR_R + LEN_2
!byte $e2, 0 + DIR_RU + LEN_9
!byte $87, 3
!byte $5a, 3
!byte $ff
!byte $63, AI_FLOATER
!byte $e3, AI_CRAWLER
!byte $4d, AI_FLOATER
!byte $eb, AI_CRAWLER
!byte $ff

; at this point we're at * = $318, the NMI VP (called on RUN/STOP+RESTORE)
; we need to point this to an RTI instruction ($40)
; we can find this in our room data as 0 + DIR_R + LEN_5
; in this case we're using Room1's second byte

; if this code breaks, the worst that can happen is that RUN/STOP+RESTORE fails
; ugly but the easiest way to fit this into the available memory without
; compromise

!word Room1 + 1

Room0 ; treasure room (exit right)
!byte $07, 2 + DIR_RD + LEN_8
!byte $81, 0 + DIR_R + LEN_6
!byte $97, 0 + DIR_RD + LEN_3
!byte $db, 3 + DIR_D + LEN_2
!byte $ec, 3
!byte $e4, 3
!byte $ff
!byte $79, AI_FLOATER
!byte $4d, AI_FLOATER
!byte $93, AI_FLOATER
!byte $ff

Room1 ; treasure room (exit left)
!byte $3a, 0 + DIR_R + LEN_5
!byte $58, 0 + DIR_RU + LEN_2
!byte $81, 1 + DIR_R + LEN_3
!byte $88, 1 + DIR_R + LEN_4
!byte $ad, 0 + DIR_R + LEN_2
!byte $c8, 0 + DIR_R + LEN_4
!byte $dd, 1 + DIR_R + LEN_2
!byte $ff
!byte $63, AI_FLOATER
!byte $b9, AI_CRAWLER
!byte $74, AI_FLOATER
!byte $ff

Room2 ; S shape
!byte $45, 0 + DIR_R + LEN_10
!byte $51, 0 + DIR_RD + LEN_3
!byte $91, 1 + DIR_R + LEN_10
!byte $db, 0 + DIR_RU + LEN_4
!byte $36, 3
!byte $ff
!byte $63, AI_FLOATER
!byte $8b, AI_CRAWLER
!byte $3b, AI_CRAWLER
!byte $aa, AI_FLOATER
!byte $ff

Room4 ; L shape
!byte $45, 0 + DIR_R + LEN_3
!byte $51, 1 + DIR_R + LEN_1
!byte $74, 0 + DIR_R + LEN_3
!byte $81, 1 + DIR_R + LEN_1
!byte $a4, 0 + DIR_R + LEN_2
!byte $b1, 1 + DIR_R + LEN_1
!byte $a9, 0 + DIR_RD + LEN_5
!byte $d3, 2 + DIR_D + LEN_2
!byte $ff
!byte $36, AI_CRAWLER
!byte $6a, AI_FLOATER
!byte $eb, AI_CRAWLER
!byte $ff

Room5 ; tree
!byte $38, 0 + DIR_R + LEN_2
!byte $57, 0 + DIR_R + LEN_4
!byte $76, 0 + DIR_R + LEN_6
!byte $95, 0 + DIR_R + LEN_9
!byte $a8, 2 + DIR_D + LEN_5
!byte $a9, 2 + DIR_D + LEN_5
!byte $b4, 0 + DIR_R + LEN_6
!byte $bc, 1 + DIR_R + LEN_3
!byte $d1, 1 + DIR_R + LEN_1
!byte $da, 0 + DIR_R + LEN_1
!byte $ff
!byte $8d, AI_CRAWLER
!byte $49, AI_CRAWLER
!byte $34, AI_FLOATER
!byte $67, AI_CRAWLER
!byte $ff

Room6 ; scattered platforms
!byte $34, 0 + DIR_R + LEN_4
!byte $65, 1 + DIR_R + LEN_6
!byte $93, 0 + DIR_R + LEN_2
!byte $99, 1 + DIR_R + LEN_5
!byte $c6, 0 + DIR_R + LEN_3
!byte $eb, 3
!byte $8c, 3
!byte $ff
!byte $a2, AI_FLOATER
!byte $2b, AI_FLOATER
!byte $59, AI_CRAWLER
!byte $bd, AI_FLOATER
!byte $ff

Room7 ; Z shape
!byte $14, 2 + DIR_RD + LEN_2
!byte $36, 1 + DIR_R + LEN_5
!byte $55, 0 + DIR_RD + LEN_2
!byte $71, 1 + DIR_R + LEN_2
!byte $77, 0 + DIR_R + LEN_8
!byte $b1, 1 + DIR_R + LEN_2
!byte $b7, 0 + DIR_R + LEN_4
!byte $6b, 3
!byte $ff
!byte $32, AI_FLOATER
!byte $67, AI_CRAWLER
!byte $aa, AI_CRAWLER
!byte $ff

Room8 ; H shape
!byte $3a, 0 + DIR_R + LEN_2
!byte $56, 3
!byte $49, 2 + DIR_D + LEN_5
!byte $63, 1 + DIR_R + LEN_9
!byte $93, 2 + DIR_D + LEN_1
!byte $99, 1 + DIR_R + LEN_3
!byte $9b, 2 + DIR_D + LEN_6
!byte $c3, 2 + DIR_D + LEN_3
!byte $b4, 2 + DIR_D + LEN_4
!byte $bc, 2 + DIR_D + LEN_4
!byte $ff
!byte $8b, AI_CRAWLER
!byte $54, AI_CRAWLER
!byte $88, AI_FLOATER
!byte $ff

Room9 ; cave
!byte $61, 2 + DIR_RU + LEN_6
!byte $19, 2 + DIR_RD + LEN_6
!byte $e3, 3
!byte $e6, 3
!byte $ff
!byte $29, AI_FLOATER
!byte $e7, AI_CRAWLER
!byte $c8, AI_FLOATER
!byte $ff

EndRoom
!byte $e4, 3
!byte $ff
!byte $d7, AI_REACTOR
!byte $d8, AI_REACTOR
!byte $e7, AI_REACTOR
!byte $e8, AI_REACTOR
!byte $ff

BoxRoom ; shell that all rooms use
!byte $00, 1 + DIR_R + LEN_16
!byte $00, 2 + DIR_D + LEN_16
!byte $0f, 2 + DIR_D + LEN_16
!byte $f0, 0 + DIR_R + LEN_16
!byte $ff
!byte $00  ; special case no reset creatures

EndOfRooms
}
EndOfRoomsUnrelocated