;
; Sprites
;
; bg  = %00
; brd = %01
; fg  = %10
; aux = %11
;

; colors to poke to screencols
    BLACK   = 8
    WHITE   = 9
    RED     = 10
    CYAN    = 11
    MAGENTA = 12
    GREEN   = 13
    BLUE    = 14
    YELLOW  = 15
    
* = $1cc8

FIRST_COLLIDABLE = 25

Tiles
!8  $BB,$AA,$FE,$EF,$FF,$CC,$3F,$30 ; 0 = grass/dirt
!8  $FF,$5E,$5D,$5D,$FF,$E5,$D5,$D5 ; 1 = brick
!8  $FD,$FD,$55,$55,$DF,$DF,$55,$55 ; 2 = simple brick
!8  $2C,$B7,$BD,$F5,$DD,$F5,$D5,$14 ; 3 = rock

!8  $AA,$AA,$11,$AA,$CC,$AA,$22,$AA ; 4 = tech floor
!8  $AA,$69,$58,$14,$25,$61,$5A,$AA ; 5 = tech plat horz
!8  $BE,$9E,$8E,$BE,$B6,$B2,$B2,$BE ; 6 = tech plat vert
!8  $28,$92,$86,$92,$86,$92,$86,$28 ; 7 = tech block

    TILE_DOOR = 33
    TILE_FIRSTPICKUP = 34
    TILE_BOOSTPACK = 34
    TILE_MISSILE = 35
    TILE_SWIPECARD = 36
    TILE_KEYCARD = 37
    TILE_HEALTH = 38

DoorTile
!8  $EB,$28,$28,$28,$28,$28,$28,$EB
BoostPackTile
!8  $30,$78,$72,$72,$72,$72,$60,$80
MissileLauncherTile
!8  $28,$28,$28,$18,$69,$DB,$69,$C3
SwipeCardTile
!8  $50,$4F,$A3,$69,$A3,$69,$6B,$55
KeyCardTile
!8  $29,$99,$AF,$65,$EB,$65,$5B,$55
HealthTile
!8  $28,$28,$28,$00,$55,$14,$14,$55

    LOGO_START = 39

Logo
!8  $28,$2A,$26,$A9,$A6,$AA,$55,$15
!8  $08,$08,$28,$29,$29,$2A,$15,$15
!8  $88,$88,$98,$AA,$AA,$69,$55,$14
!8  $A8,$A4,$AA,$69,$68,$6A,$15,$14
!8  $0A,$2A,$29,$1A,$AA,$69,$55,$15
!8  $AA,$69,$69,$28,$24,$24,$14,$04
!8  $A0,$A0,$A8,$98,$AA,$9A,$55,$44
!8  $A0,$A8,$98,$A8,$A6,$A6,$55,$44

* = $1c00
StartOfSpritesUnrelocated
!pseudopc $101 {

Sprites
PlayerSprites
!8  CYAN, $04,$2C,$24,$29,$04,$0A,$22,$11
!8  CYAN, $10,$38,$18,$68,$10,$A0,$88,$44
!8  CYAN, $04,$2C,$24,$29,$04,$0A,$18,$04
!8  CYAN, $10,$38,$18,$68,$10,$A0,$24,$10

ReactorSprite
!8  BLUE, $28,$AA,$96,$AA,$96,$AA,$BE,$AA

MissileSprites
!8  WHITE, $04,$0a,$04
!8  WHITE, $10,$a0,$10

BatSprites
!8  BLUE, $80,$22,$28,$9A,$A6,$8A,$82,$80
!8  BLUE, $02,$88,$28,$A6,$9A,$A2,$82,$02

JellySkullSprites
!8  WHITE, $28,$8E,$82,$9A,$A4,$18,$24,$08
!8  WHITE, $28,$B2,$82,$A6,$1A,$24,$18,$20

BloodMonkeySprites
!8  BLUE, $14,$1A,$5A,$54,$D5,$D1,$01,$C4
!8  BLUE, $14,$A4,$A5,$15,$57,$47,$40,$13
!8  BLUE, $14,$1A,$5A,$54,$D4,$10,$10,$4C
!8  BLUE, $14,$A4,$A5,$15,$17,$04,$04,$31

ExplosionSprites
!8  YELLOW, $00,$14,$15,$59,$65,$69,$55,$14
!8  YELLOW, $14,$24,$59,$65,$69,$69,$65,$14
!8  YELLOW, $14,$69,$9A,$96,$51,$45,$10,$04
!8  BLUE, $18,$20,$58,$82,$61,$08,$00,$00

LionixSprites
!8  CYAN, $0C,$8F,$27,$9E,$5C,$53,$60,$A0
!8  CYAN, $30,$F2,$D8,$B6,$35,$C5,$09,$0A
!8  CYAN, $8C,$2F,$27,$9E,$5F,$50,$60,$88
!8  CYAN, $32,$F8,$D8,$B6,$F5,$05,$09,$22

EndOfSprites
}
EndOfSpritesUnrelocated